#!/usr/bin/perl


# // 饤֥
use strict;
use DBI;
use lib './libraries';
use pkLab;
use subLab;


# // եɤ߹
my %config = ConfigRead( 'config.cgi', \&SjisToEuc );
# -- ʸֹ楻å
$config{template_code_char} = ( '', 'sjis', 'euc', 'utf8' ) [ $config{template_code} ];


# // SQLite³
my $db_noexist;
unless ( -s $config{db_file} ) { $db_noexist = 1; }
my $dbh = DBI->connect( "dbi:SQLite:dbname=$config{db_file}" ) or die $DBI::errstr;
if ( $db_noexist ) { InitDb( $dbh ); chmod 0666, $config{db_file}; }
my $sth;


# // եǡѿ
my %form = FormData;
my %embed;


# // Ѥκǿmini.cgi,mini.txtѡ
my @mini_news_list;
$sth = $dbh->prepare( <<SQL );
SELECT
  * ,
  STRFTIME('%Y', show_timestamp) AS year ,
  STRFTIME('%m', show_timestamp) AS month ,
  STRFTIME('%d', show_timestamp) AS day
FROM
  news
ORDER BY
  show_timestamp DESC ,
  post_timestamp DESC
LIMIT ?
SQL
$sth->execute( $config{mini_show_count} );
while ( my $ref = $sth->fetchrow_hashref ) {
	push @mini_news_list, $ref;
}
$embed{mini_template} = Template( './mini.txt', 'news_list' => ( @mini_news_list ? \@mini_news_list : undef ) );


# // ܺ٥ڡɽ
if ( $form{seq} > 0 ) {
	# -- ǡɤ߹
	$sth = $dbh->prepare( <<SQL );
SELECT
  * ,
  STRFTIME('%Y', show_timestamp) AS year ,
  STRFTIME('%m', show_timestamp) AS month ,
  STRFTIME('%d', show_timestamp) AS day ,
  STRFTIME('%w', show_timestamp) AS week
FROM
  news
WHERE
  seq=?
LIMIT 1
SQL
	$sth->execute( $form{seq} );
	( my $ref ) = $sth->fetchrow_hashref;
	$$ref{week} = (qw/      /)[$$ref{week}];

	# -- ϡλ
	Header;
	print Replace( './detail.txt', \%config, %form, %config, %embed, %$ref );
	exit;
}


# // ڡʥӽ
my %page = PageNaviSQL (
	$dbh ,
	$form{page} ,
	$config{news_show_count} ,
	'SELECT COUNT(*) FROM news' ,
);


# // 
my @news_list;
$sth = $dbh->prepare( <<SQL );
SELECT
  * ,
  STRFTIME('%Y', show_timestamp) AS year ,
  STRFTIME('%m', show_timestamp) AS month ,
  STRFTIME('%d', show_timestamp) AS day
FROM
  news
ORDER BY
  show_timestamp DESC ,
  post_timestamp DESC
LIMIT ?
OFFSET ?
SQL
$sth->execute( @page{qw/limit offset/} );
while ( my $ref = $sth->fetchrow_hashref ) {
	push @news_list, $ref;
}
$embed{news_list} = \@news_list if @news_list;


# // 
Header;
print Replace( './news.txt', \%config, %form, %config, %embed, %page );

exit;

# ====================================================================
# Υץॽ/ͭϥܤ˵°ޤ̵Ǥǲ
# ¤///򿯳붲Τ԰١ڤӤɽ
# /ڶؤޤޤץˤäư줿Զ
# ȥ֥˴ؤơϰڴͿޤΤǤλ
# --------------------------------------------------------------------
#                               󥿥CGIhttp://kantaro-cgi.com/
#                                     ܡhttp://kazaoki.jp/
# ====================================================================
